# this import trigger a connection to Hecuba database
from hecuba import StorageObj

# COMPSs/PyCOMPSs imports
from pycompss.api.task import task
from pycompss.api.binary import binary
from pycompss.api.constraint import constraint
from pycompss.api.mpi import mpi
from pycompss.api.api import compss_wait_on
from pycompss.api.api import compss_barrier
from pycompss.api.api import TaskGroup
from pycompss.api.api import compss_barrier_group
from pycompss.api.parameter import *
from pycompss.api.on_failure import on_failure

from C3Schecker import utils
from hecuba.esm_dynamic_analysis_results import *

# things we need:
# 1 - every 30 seconds, check the state of state of the members and determine which members to prune
# 2 - every n time steps,  perform the analysis of the model data

def get_members_state(exp_id):
   # todo add connection to Hecuba
   print("######################## checking member state for experiment" + exp_id + "#########################")
   exp_member_status = esm_dynamic_analysis_results("Keyspace.Table")
   return exp_member_status


def esm_dynamic_analysis(exp_id):
    print("######################## performing dynamic analysys for experiment" + exp_id + "#########################")

@on_failure(management='IGNORE', returns=0)
@task( returns=int, exp_id={Type:IN}, log_pruning={Type: FILE_OUT, StdIOStream: STDOUT})
def esm_pruning(exp_id, log_pruning):
   # 1 - connect to hecuba and obtain values
   #t = threading.Timer(10.0, esm_pruning, [exp_id, log_pruning])
   #t.start()
   try:
     print("################################################### lauching pruning " + str(time.time()) + "###################################################")
     get_members_state(exp_id)
     return 0
   except:
     print("ERRROR !!!!!!!!!!! An exception occurred")


# for testing purposes
if __name__ == "__main__":
   print("Running Dynamic analysis Agent" )
   # first parameter: number of ensemble members
   # 0 - create a ramdon nr for the experiment id
   i = 0
   while (i < 10) :
      compss_wait_on(esm_pruning("223234", "223234_pruning_log.out"))
      time.sleep(5)

