#todo: to be remplaced by python file
#todo: add also the launching of Hecuba storage, is it possible based on this hint
#https://compss-doc.readthedocs.io/en/stable/Sections/06_Persistent_Storage/05_Own_interface.html?highlight=enqueue_compss#using-enqueue-compss

module load COMPSs
module use /apps/HECUBA/modulefiles
module load Hecuba/1.0_api
module load python
# experiment configuration
# only parameter - #CORES
export FESOM_CORES=$1
export QOS=$2
export MEMBERS=$3
# for the moment hardcoded until COMPS is patched
export FESOM_WORKINGDIR="/home/bsc32/bsc32044/pycompss_workflow_tests/1948"
export FESOM_EXE="fesom.x"
export NODE_ALLOCATION=$(((${FESOM_CORES}/48)*${MEMBERS}))
echo "Number of cores: ${FESOM_CORES}"
echo "Number of nodes to be used: ${NODE_ALLOCATION}"

#added by support to prevent the segmentation fault
ulimit -Ss unlimited


#PATH_TO_COMPSS_INSTALLATION/enqueue_compss \
#    --num_nodes = 4 \
#    --storage_props = storage_props.cfg \
#    --storage_home=$HECUBA_ROOT/compss/ \
#    --scheduler=es.bsc.compss.scheduler.fifodatanew.FIFODataScheduler \
#    --lang=python \
#    $(pwd)/myapp.py

# Sample invocation of this script:
# ./launch_mn4.sh 288 debug 1
# ./launch_mn4.sh 144 debug 3
# $1 number of cores needed by the task
# $2 QoS to be used (determines the queue)
# $3 number of simulations of the ensemble

# launch hecuba & dynamic analysis process
enqueue_compss -t  --sc_cfg=mn.cfg --log_level=debug  --storage_props="$PWD/hecuba/storage_props.cfg" --storage_home="$PWD/hecuba"   --job_name=pruning --exec_time=20 --num_nodes=1  --pythonpath=$PWD  esm_pruning.py
# launch the simulation
enqueue_compss -t  --sc_cfg=mn.cfg --qos=${QOS} --log_level=debug  --job_name=fesom2 --exec_time=20 --worker_in_master_cpus=48 --num_nodes=${NODE_ALLOCATION}  --pythonpath=$PWD  esm_simulation.py ${MEMBERS}
